• Home
  • Line#
  • Scopes#
  • Navigate#
  • Raw
  • Download
1#!/bin/sh
2# SPDX-License-Identifier: GPL-2.0
3#
4# link vmlinux
5#
6# vmlinux is linked from the objects selected by $(KBUILD_VMLINUX_OBJS) and
7# $(KBUILD_VMLINUX_LIBS). Most are built-in.a files from top-level directories
8# in the kernel tree, others are specified in arch/$(ARCH)/Makefile.
9# $(KBUILD_VMLINUX_LIBS) are archives which are linked conditionally
10# (not within --whole-archive), and do not require symbol indexes added.
11#
12# vmlinux
13#   ^
14#   |
15#   +--< $(KBUILD_VMLINUX_OBJS)
16#   |    +--< init/built-in.a drivers/built-in.a mm/built-in.a + more
17#   |
18#   +--< $(KBUILD_VMLINUX_LIBS)
19#   |    +--< lib/lib.a + more
20#   |
21#   +-< ${kallsymso} (see description in KALLSYMS section)
22#
23# vmlinux version (uname -v) cannot be updated during normal
24# descending-into-subdirs phase since we do not yet know if we need to
25# update vmlinux.
26# Therefore this step is delayed until just before final link of vmlinux.
27#
28# System.map is generated to document addresses of all kernel symbols
29
30# Error out on error
31set -e
32
33LD="$1"
34KBUILD_LDFLAGS="$2"
35LDFLAGS_vmlinux="$3"
36
37# Nice output in kbuild format
38# Will be supressed by "make -s"
39info()
40{
41	if [ "${quiet}" != "silent_" ]; then
42		printf "  %-7s %s\n" "${1}" "${2}"
43	fi
44}
45
46# Generate a linker script to ensure correct ordering of initcalls.
47gen_initcalls()
48{
49	info GEN .tmp_initcalls.lds
50
51	${PYTHON} ${srctree}/scripts/jobserver-exec		\
52	${PERL} ${srctree}/scripts/generate_initcall_order.pl	\
53		${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}	\
54		> .tmp_initcalls.lds
55}
56
57# If CONFIG_LTO_CLANG is selected, collect generated symbol versions into
58# .tmp_symversions.lds
59gen_symversions()
60{
61	info GEN .tmp_symversions.lds
62	rm -f .tmp_symversions.lds
63
64	for o in ${KBUILD_VMLINUX_OBJS} ${KBUILD_VMLINUX_LIBS}; do
65		if [ -f ${o}.symversions ]; then
66			cat ${o}.symversions >> .tmp_symversions.lds
67		fi
68	done
69}
70
71# Link of vmlinux.o used for section mismatch analysis
72# ${1} output file
73modpost_link()
74{
75	local objects
76	local lds=""
77
78	objects="--whole-archive				\
79		${KBUILD_VMLINUX_OBJS}				\
80		--no-whole-archive				\
81		--start-group					\
82		${KBUILD_VMLINUX_LIBS}				\
83		--end-group"
84
85	if [ -n "${CONFIG_LTO_CLANG}" ]; then
86		gen_initcalls
87		lds="-T .tmp_initcalls.lds"
88
89		if [ -n "${CONFIG_MODVERSIONS}" ]; then
90			gen_symversions
91			lds="${lds} -T .tmp_symversions.lds"
92		fi
93
94		# This might take a while, so indicate that we're doing
95		# an LTO link
96		info LTO ${1}
97	else
98		info LD ${1}
99	fi
100
101	${LD} ${KBUILD_LDFLAGS} -r -o ${1} ${lds} ${objects}
102}
103
104objtool_link()
105{
106	local objtoolcmd;
107	local objtoolopt;
108
109	if [ "${CONFIG_LTO_CLANG} ${CONFIG_STACK_VALIDATION}" = "y y" ]; then
110		# Don't perform vmlinux validation unless explicitly requested,
111		# but run objtool on vmlinux.o now that we have an object file.
112		if [ -n "${CONFIG_UNWINDER_ORC}" ]; then
113			objtoolcmd="orc generate"
114		fi
115
116		objtoolopt="${objtoolopt} --duplicate"
117
118		if [ -n "${CONFIG_FTRACE_MCOUNT_USE_OBJTOOL}" ]; then
119			objtoolopt="${objtoolopt} --mcount"
120		fi
121	fi
122
123	if [ -n "${CONFIG_VMLINUX_VALIDATION}" ]; then
124		objtoolopt="${objtoolopt} --noinstr"
125	fi
126
127	if [ -n "${objtoolopt}" ]; then
128		if [ -z "${objtoolcmd}" ]; then
129			objtoolcmd="check"
130		fi
131		objtoolopt="${objtoolopt} --vmlinux"
132		if [ -n "${CONFIG_CPU_UNRET_ENTRY}" ]; then
133			objtoolopt="${objtoolopt} --unret"
134		fi
135		if [ -z "${CONFIG_FRAME_POINTER}" ]; then
136			objtoolopt="${objtoolopt} --no-fp"
137		fi
138		if [ -n "${CONFIG_GCOV_KERNEL}" ] || [ -n "${CONFIG_LTO_CLANG}" ]; then
139			objtoolopt="${objtoolopt} --no-unreachable"
140		fi
141		if [ -n "${CONFIG_RETPOLINE}" ]; then
142			objtoolopt="${objtoolopt} --retpoline"
143		fi
144		if [ -n "${CONFIG_X86_SMAP}" ]; then
145			objtoolopt="${objtoolopt} --uaccess"
146		fi
147		if [ -n "${CONFIG_SLS}" ]; then
148			objtoolopt="${objtoolopt} --sls"
149		fi
150		info OBJTOOL ${1}
151		tools/objtool/objtool ${objtoolcmd} ${objtoolopt} ${1}
152	fi
153}
154
155# Link of vmlinux
156# ${1} - output file
157# ${2}, ${3}, ... - optional extra .o files
158vmlinux_link()
159{
160	local lds="${objtree}/${KBUILD_LDS}"
161	local output=${1}
162	local objects
163	local strip_debug
164
165	info LD ${output}
166
167	# skip output file argument
168	shift
169
170	# The kallsyms linking does not need debug symbols included.
171	if [ "$output" != "${output#.tmp_vmlinux.kallsyms}" ] ; then
172		strip_debug=-Wl,--strip-debug
173	fi
174
175	if [ "${SRCARCH}" != "um" ]; then
176		if [ -n "${CONFIG_LTO_CLANG}" ]; then
177			# Use vmlinux.o instead of performing the slow LTO
178			# link again.
179			objects="--whole-archive		\
180				vmlinux.o 			\
181				--no-whole-archive		\
182				${@}"
183		else
184			objects="--whole-archive		\
185				${KBUILD_VMLINUX_OBJS}		\
186				--no-whole-archive		\
187				--start-group			\
188				${KBUILD_VMLINUX_LIBS}		\
189				--end-group			\
190				${@}"
191		fi
192
193		${LD} ${KBUILD_LDFLAGS} ${LDFLAGS_vmlinux}	\
194			${strip_debug#-Wl,}			\
195			-o ${output}				\
196			-T ${lds} ${objects}
197	else
198		objects="-Wl,--whole-archive			\
199			${KBUILD_VMLINUX_OBJS}			\
200			-Wl,--no-whole-archive			\
201			-Wl,--start-group			\
202			${KBUILD_VMLINUX_LIBS}			\
203			-Wl,--end-group				\
204			${@}"
205
206		${CC} ${CFLAGS_vmlinux}				\
207			${strip_debug}				\
208			-o ${output}				\
209			-Wl,-T,${lds}				\
210			${objects}				\
211			-lutil -lrt -lpthread
212		rm -f linux
213	fi
214}
215
216# generate .BTF typeinfo from DWARF debuginfo
217# ${1} - vmlinux image
218# ${2} - file to dump raw BTF data into
219gen_btf()
220{
221	local pahole_ver
222
223	if ! [ -x "$(command -v ${PAHOLE})" ]; then
224		echo >&2 "BTF: ${1}: pahole (${PAHOLE}) is not available"
225		return 1
226	fi
227
228	pahole_ver=$(${PAHOLE} --version | sed -E 's/v([0-9]+)\.([0-9]+)/\1\2/')
229	if [ "${pahole_ver}" -lt "116" ]; then
230		echo >&2 "BTF: ${1}: pahole version $(${PAHOLE} --version) is too old, need at least v1.16"
231		return 1
232	fi
233
234	vmlinux_link ${1}
235
236	info "BTF" ${2}
237	LLVM_OBJCOPY="${OBJCOPY}" ${PAHOLE} -J ${PAHOLE_FLAGS} ${1}
238
239	# Create ${2} which contains just .BTF section but no symbols. Add
240	# SHF_ALLOC because .BTF will be part of the vmlinux image. --strip-all
241	# deletes all symbols including __start_BTF and __stop_BTF, which will
242	# be redefined in the linker script. Add 2>/dev/null to suppress GNU
243	# objcopy warnings: "empty loadable segment detected at ..."
244	${OBJCOPY} --only-section=.BTF --set-section-flags .BTF=alloc,readonly \
245		--strip-all ${1} ${2} 2>/dev/null
246	# Change e_type to ET_REL so that it can be used to link final vmlinux.
247	# GNU ld 2.35+ and lld do not allow an ET_EXEC input.
248	if [ -n "${CONFIG_CPU_BIG_ENDIAN}" ]; then
249		et_rel='\0\1'
250	else
251		et_rel='\1\0'
252	fi
253	printf "${et_rel}" | dd of=${2} conv=notrunc bs=1 seek=16 status=none
254}
255
256# Create ${2} .S file with all symbols from the ${1} object file
257kallsyms()
258{
259	local kallsymopt;
260
261	if [ -n "${CONFIG_KALLSYMS_ALL}" ]; then
262		kallsymopt="${kallsymopt} --all-symbols"
263	fi
264
265	if [ -n "${CONFIG_KALLSYMS_ABSOLUTE_PERCPU}" ]; then
266		kallsymopt="${kallsymopt} --absolute-percpu"
267	fi
268
269	if [ -n "${CONFIG_KALLSYMS_BASE_RELATIVE}" ]; then
270		kallsymopt="${kallsymopt} --base-relative"
271	fi
272
273	info KSYMS ${2}
274
275	if [ -n "${CONFIG_CFI_CLANG}" ]; then
276		${PERL} ${srctree}/scripts/generate_cfi_kallsyms.pl ${1} | \
277			sort -n > .tmp_kallsyms
278	else
279		${NM} -n ${1} > .tmp_kallsyms
280	fi
281
282	scripts/kallsyms ${kallsymopt} < .tmp_kallsyms > ${2}
283}
284
285# Perform one step in kallsyms generation, including temporary linking of
286# vmlinux.
287kallsyms_step()
288{
289	kallsymso_prev=${kallsymso}
290	kallsyms_vmlinux=.tmp_vmlinux.kallsyms${1}
291	kallsymso=${kallsyms_vmlinux}.o
292	kallsyms_S=${kallsyms_vmlinux}.S
293
294	vmlinux_link ${kallsyms_vmlinux} "${kallsymso_prev}" ${btf_vmlinux_bin_o}
295	kallsyms ${kallsyms_vmlinux} ${kallsyms_S}
296
297	info AS ${kallsyms_S}
298	${CC} ${NOSTDINC_FLAGS} ${LINUXINCLUDE} ${KBUILD_CPPFLAGS} \
299	      ${KBUILD_AFLAGS} ${KBUILD_AFLAGS_KERNEL} \
300	      -c -o ${kallsymso} ${kallsyms_S}
301}
302
303# Create map file with all symbols from ${1}
304# See mksymap for additional details
305mksysmap()
306{
307	${CONFIG_SHELL} "${srctree}/scripts/mksysmap" ${1} ${2}
308}
309
310sorttable()
311{
312	${objtree}/scripts/sorttable ${1}
313}
314
315# Delete output files in case of error
316cleanup()
317{
318	rm -f .btf.*
319	rm -f .tmp_System.map
320	rm -f .tmp_kallsyms
321	rm -f .tmp_initcalls.lds
322	rm -f .tmp_symversions.lds
323	rm -f .tmp_vmlinux*
324	rm -f System.map
325	rm -f vmlinux
326	rm -f vmlinux.o
327}
328
329on_exit()
330{
331	if [ $? -ne 0 ]; then
332		cleanup
333	fi
334}
335trap on_exit EXIT
336
337on_signals()
338{
339	exit 1
340}
341trap on_signals HUP INT QUIT TERM
342
343# Use "make V=1" to debug this script
344case "${KBUILD_VERBOSE}" in
345*1*)
346	set -x
347	;;
348esac
349
350if [ "$1" = "clean" ]; then
351	cleanup
352	exit 0
353fi
354
355# We need access to CONFIG_ symbols
356. include/config/auto.conf
357
358# Update version
359info GEN .version
360if [ -r .version ]; then
361	VERSION=$(expr 0$(cat .version) + 1)
362	echo $VERSION > .version
363else
364	rm -f .version
365	echo 1 > .version
366fi;
367
368# final build of init/
369${MAKE} -f "${srctree}/scripts/Makefile.build" obj=init need-builtin=1
370
371#link vmlinux.o
372modpost_link vmlinux.o
373objtool_link vmlinux.o
374
375# modpost vmlinux.o to check for section mismatches
376${MAKE} -f "${srctree}/scripts/Makefile.modpost" MODPOST_VMLINUX=1
377
378info MODINFO modules.builtin.modinfo
379${OBJCOPY} -j .modinfo -O binary vmlinux.o modules.builtin.modinfo
380info GEN modules.builtin
381# The second line aids cases where multiple modules share the same object.
382tr '\0' '\n' < modules.builtin.modinfo | sed -n 's/^[[:alnum:]:_]*\.file=//p' |
383	tr ' ' '\n' | uniq | sed -e 's:^:kernel/:' -e 's/$/.ko/' > modules.builtin
384
385btf_vmlinux_bin_o=""
386if [ -n "${CONFIG_DEBUG_INFO_BTF}" ]; then
387	btf_vmlinux_bin_o=.btf.vmlinux.bin.o
388	if ! gen_btf .tmp_vmlinux.btf $btf_vmlinux_bin_o ; then
389		echo >&2 "Failed to generate BTF for vmlinux"
390		echo >&2 "Try to disable CONFIG_DEBUG_INFO_BTF"
391		exit 1
392	fi
393fi
394
395kallsymso=""
396kallsymso_prev=""
397kallsyms_vmlinux=""
398if [ -n "${CONFIG_KALLSYMS}" ]; then
399
400	# kallsyms support
401	# Generate section listing all symbols and add it into vmlinux
402	# It's a three step process:
403	# 1)  Link .tmp_vmlinux1 so it has all symbols and sections,
404	#     but __kallsyms is empty.
405	#     Running kallsyms on that gives us .tmp_kallsyms1.o with
406	#     the right size
407	# 2)  Link .tmp_vmlinux2 so it now has a __kallsyms section of
408	#     the right size, but due to the added section, some
409	#     addresses have shifted.
410	#     From here, we generate a correct .tmp_kallsyms2.o
411	# 3)  That link may have expanded the kernel image enough that
412	#     more linker branch stubs / trampolines had to be added, which
413	#     introduces new names, which further expands kallsyms. Do another
414	#     pass if that is the case. In theory it's possible this results
415	#     in even more stubs, but unlikely.
416	#     KALLSYMS_EXTRA_PASS=1 may also used to debug or work around
417	#     other bugs.
418	# 4)  The correct ${kallsymso} is linked into the final vmlinux.
419	#
420	# a)  Verify that the System.map from vmlinux matches the map from
421	#     ${kallsymso}.
422
423	kallsyms_step 1
424	kallsyms_step 2
425
426	# step 3
427	size1=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso_prev})
428	size2=$(${CONFIG_SHELL} "${srctree}/scripts/file-size.sh" ${kallsymso})
429
430	if [ $size1 -ne $size2 ] || [ -n "${KALLSYMS_EXTRA_PASS}" ]; then
431		kallsyms_step 3
432	fi
433fi
434
435vmlinux_link vmlinux "${kallsymso}" ${btf_vmlinux_bin_o}
436
437# fill in BTF IDs
438if [ -n "${CONFIG_DEBUG_INFO_BTF}" -a -n "${CONFIG_BPF}" ]; then
439	info BTFIDS vmlinux
440	${RESOLVE_BTFIDS} vmlinux
441fi
442
443if [ -n "${CONFIG_BUILDTIME_TABLE_SORT}" ]; then
444	info SORTTAB vmlinux
445	if ! sorttable vmlinux; then
446		echo >&2 Failed to sort kernel tables
447		exit 1
448	fi
449fi
450
451info SYSMAP System.map
452mksysmap vmlinux System.map
453
454# step a (see comment above)
455if [ -n "${CONFIG_KALLSYMS}" ]; then
456	mksysmap ${kallsyms_vmlinux} .tmp_System.map
457
458	if ! cmp -s System.map .tmp_System.map; then
459		echo >&2 Inconsistent kallsyms data
460		echo >&2 Try "make KALLSYMS_EXTRA_PASS=1" as a workaround
461		exit 1
462	fi
463fi
464